import { Context } from "koa";
import { Mountable } from "@sealcode/sealgen";
import Router from "@koa/router";
import { sleep } from "../util";

export const actionName = "motd";
export function pick<T>(options: readonly T[]): T {
	const random = Math.random();
	const ret = options[Math.floor(random * options.length)];
	return ret;
}

export async function getMOTD() {
	await sleep(parseInt(process.env.SEALIOUS_DB_DELAY || "0") / 2);
	return pick([
		"Never don't give up",
		"Say no to yes. Say pizza to drugs",
		"Bądź kreatwyny",
		"Inside you there are two wolves",
	]);
}

export default new (class motdRedirect extends Mountable {
	// eslint-disable-next-line @typescript-eslint/no-unused-vars
	async canAccess(_: Context) {
		return { canAccess: true, message: "" };
	}

	mount(router: Router, path: string) {
		router.get(path, async (ctx) => {
			ctx.body = { motd: await getMOTD() };
		});
	}
})();
