import { Context } from "koa";
import { Page } from "@sealcode/sealgen";

export const actionName = "React";

export default new (class ReactPage extends Page {
	// eslint-disable-next-line @typescript-eslint/no-unused-vars
	async canAccess(_: Context) {
		return { canAccess: true, message: "" };
	}

	async render(ctx: Context) {
		return /* HTML */ `<!DOCTYPE html>
			<html>
				<head>
					<title>React version</title>
					<link href="/dist/style.css" rel="stylesheet" type="text/css" />
					<script
						src="https://unpkg.com/react@18/umd/react.production.min.js"
						crossorigin
					></script>
					<script
						src="https://unpkg.com/react-dom@18/umd/react-dom.production.min.js"
						crossorigin
					></script>
				</head>
				<body>
					<div id="app"></div>
				</body>
				<script src="/dist/react.js"></script>
			</html>`;
	}
})();
