"use strict";

const e = React.createElement;

const domContainer = document.querySelector("#app");
const root = ReactDOM.createRoot(domContainer);

function footer() {
	const [motd, setMotd] = React.useState("");
	React.useEffect(async () => {
		const response = await fetch("/motd/");
		const { motd } = await response.json();
		setMotd(motd);
	}, []);
	return <div className="footer">Copyright 2022. {motd}</div>;
}

function navbar() {
	return (
		<div className="navbar">
			<div className="logo">My app</div>
			<div>
				<a href="/react/">react</a> <a href="/ssr1/">ssr1</a>{" "}
				<a href="/ssr2/">ssr2</a> <a href="/ssr25/">ssr2.5</a>{" "}
				<a href="/ssr3/">ssr3</a> <a href="/ssr4/">ssr4</a>{" "}
			</div>
		</div>
	);
}

function sidebar() {
	return (
		<div className="sidebar">
			<ul className="filters">
				<li>
					<input type="checkbox" /> Filtr1
				</li>
				<li>
					<input type="checkbox" /> Filtr2
				</li>
				<li>
					<input type="checkbox" /> Filtr3
				</li>
				<li>
					<input type="checkbox" /> Filtr4
				</li>
			</ul>
		</div>
	);
}

function renderItem({ item }) {
	return (
		<li className="item">
			<h3>{item.title}</h3>
			<p>{item.description}</p>
		</li>
	);
}

function content() {
	const [isLoading, setIsLoading] = React.useState(true);
	const [items, setItems] = React.useState([]);
	React.useEffect(async function () {
		const response = await fetch("/api/v1/collections/posts");
		const { items } = await response.json();
		setItems(items);
		setIsLoading(false);
	}, []);
	if (isLoading) {
		return (
			<div className="content">
				<div className="loading">Loading.....</div>
			</div>
		);
	}
	return (
		<div className="content">
			<ul className="items">{items.map((item) => e(renderItem, { item }))}</ul>
		</div>
	);
}

function app() {
	return (
		<>
			{e(navbar)}
			{e(sidebar)}
			{e(content)}
			{e(footer)}
		</>
	);
}

root.render(e(app));
